var path = require('path');
var webpack = require('webpack');

module.exports = {
    entry: "./src/index",
    output: {
        filename: "bundle.js",
        path: path.join(__dirname, "dist")
    },

    // Enable sourcemaps for debugging webpack's output.
    devtool: "source-map",

    resolve: {
        // Add '.ts' and '.tsx' as resolvable extensions.
        extensions: [".webpack.js", ".web.js", ".ts", ".tsx", ".js"]
    },

    module: {
        rules: [
            {
                enforce: "pre", // может быть post см. https://webpack.js.org/configuration/module/#module-rules
                // All output '.js' files will have any sourcemaps re-processed by 'source-map-loader'.
                test: /\.js$/, loader: "source-map-loader",
                exclude: /node-modules/,
            },
            {
                test: /\.tsx?$/,
                // loaders: [
                //     "babel-loader?presets[]=es2015",
                //     "ts-loader"
                // ],
                loader: "ts-loader",
                exclude: /node-modules/,
            }
        ],
    },

    // When importing a module whose path matches one of the following, just
    // assume a corresponding global variable exists and use that instead.
    // This is important because it allows us to avoid bundling all of our
    // dependencies, which allows browsers to cache those libraries between builds.
    // externals: {
    //     "react": "React",
    //     "react-dom": "ReactDOM"
    // },

    plugins: [
        new webpack.LoaderOptionsPlugin({
            debug: true
        })
    ],

    devServer: {
        // inline: true,
        // hot: true,
        contentBase: '.',
        publicPath: 'http://localhost:8080/',
        setup: function (app) {
            app.get(".", function (req, res) {
                console.log('SIMA @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@', req.path);
                var p = path.dirname(__dirname);
                p = path.join(p, 'index.html');
                // console.log('SIMA @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@', p);
                // res.sendFile(p);
            });
        },
    }
};
